<?php 
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of Typo plugin for Dotclear 2.
#
# Copyright (c) 2008 Franck Paul and contributors
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

require_once dirname(__FILE__).'/inc/smartypants.php';
require_once dirname(__FILE__).'/inc/hyphenation.php';

/* Add behavior callback for comments */
$core->addBehavior('coreBeforeCommentCreate',array('dcTypo','updateTypoComments'));
$core->addBehavior('publicBeforeCommentPreview',array('dcTypo','previewTypoComments'));

class dcTypo
{
	public static function updateTypoComments(&$blog,&$cur)
	{
		global $core;
		if ($core->blog->settings->typo_active && ($core->blog->settings->typo_comments || $core->blog->settings->typo_hyphenation_comments))
		{
			/* Transform typo for comment content (XHTML) */
			if (!(boolean)$cur->comment_trackback) {
				if ($cur->comment_content != null) {
					if ($core->blog->settings->typo_comments)
						$cur->comment_content = SmartyPants($cur->comment_content);

					if ($core->blog->settings->typo_hyphenation_comments) {
						/* Preset for hyphenation */
						$language = "";
						// Find language defined for the entry - TO BE COMPLETED
//						if (isset($cur->post_lang)) {
//							$language = $cur->post_lang;
//						} else {
							// Keep default language of the blog
							$language = $core->blog->settings->lang;
//						}
						$hyphenate = preset_hyphenation($language, $path_to_patterns, $dictionary,
							$leftmin, $rightmin, $charmin);
						if ($hyphenate)
							$cur->comment_content = hyphenation($cur->comment_content, $language, $path_to_patterns, $dictionary,
								$leftmin, $rightmin, $charmin);
					}
				}
			}
		}
	}
	public static function previewTypoComments(&$prv)
	{
		global $core;
		if ($core->blog->settings->typo_active && ($core->blog->settings->typo_comments || $core->blog->settings->typo_hyphenation_comments))
		{
			/* Transform typo for comment content (XHTML) */
			if ($prv['content'] != null) {
				if ($core->blog->settings->typo_comments)
					$prv['content'] = SmartyPants($prv['content']);

				if ($core->blog->settings->typo_hyphenation_comments) {
					/* Preset for hyphenation */
					$language = "";
					// Find language defined for the entry - TO BE COMPLETED
//					if (isset($prv['post_lang'])) {
//						$language = $prv['post_lang'];
//					} else {
						// Keep default language of the blog
						$language = $core->blog->settings->lang;
//					}
					$hyphenate = preset_hyphenation($language, $path_to_patterns, $dictionary,
						$leftmin, $rightmin, $charmin);
					if ($hyphenate)
						$prv['content'] = hyphenation($prv['content'], $language, $path_to_patterns, $dictionary,
							$leftmin, $rightmin, $charmin);
				}
			}
		}
	}
}
?>
